#pragma once
#include "uCalcNET.h"
#include <ctime>

namespace uCalcDemoVC_NET {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
   using namespace System::Diagnostics;

	/// <summary>
	/// Summary for MyForm
	/// </summary>
	public ref class MyForm : public System::Windows::Forms::Form
	{
	public:
		MyForm(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~MyForm()
		{
			if (components)
			{
				delete components;
			}
		}
   private: System::Windows::Forms::Label^  lblElapsed;
   protected:
   internal: System::Windows::Forms::ComboBox^  cmbNumericFormat;
   private:
   internal: System::Windows::Forms::Label^  lblFPU;
   internal: System::Windows::Forms::CheckedListBox^  chkFPU;
   internal: System::Windows::Forms::Button^  btnSummation;
   internal: System::Windows::Forms::Label^  Label1;
   internal: System::Windows::Forms::TextBox^  txtSumMax;
   internal: System::Windows::Forms::TextBox^  txtSumExpression;
   internal: System::Windows::Forms::TextBox^  txtSumResult;
   internal: System::Windows::Forms::Button^  btnPlot;
   internal: System::Windows::Forms::PictureBox^  PictureBox1;
   internal: System::Windows::Forms::TextBox^  txtPlotExpression;
   internal: System::Windows::Forms::Button^  btnDefine;
   internal: System::Windows::Forms::ComboBox^  cmbDefine;
   internal: System::Windows::Forms::ComboBox^  cmbExpression;
   internal: System::Windows::Forms::Button^  btnEval;
   internal: System::Windows::Forms::TextBox^  txtResult;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
         this->lblElapsed = (gcnew System::Windows::Forms::Label());
         this->cmbNumericFormat = (gcnew System::Windows::Forms::ComboBox());
         this->lblFPU = (gcnew System::Windows::Forms::Label());
         this->chkFPU = (gcnew System::Windows::Forms::CheckedListBox());
         this->btnSummation = (gcnew System::Windows::Forms::Button());
         this->Label1 = (gcnew System::Windows::Forms::Label());
         this->txtSumMax = (gcnew System::Windows::Forms::TextBox());
         this->txtSumExpression = (gcnew System::Windows::Forms::TextBox());
         this->txtSumResult = (gcnew System::Windows::Forms::TextBox());
         this->btnPlot = (gcnew System::Windows::Forms::Button());
         this->PictureBox1 = (gcnew System::Windows::Forms::PictureBox());
         this->txtPlotExpression = (gcnew System::Windows::Forms::TextBox());
         this->btnDefine = (gcnew System::Windows::Forms::Button());
         this->cmbDefine = (gcnew System::Windows::Forms::ComboBox());
         this->cmbExpression = (gcnew System::Windows::Forms::ComboBox());
         this->btnEval = (gcnew System::Windows::Forms::Button());
         this->txtResult = (gcnew System::Windows::Forms::TextBox());
         (cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->PictureBox1))->BeginInit();
         this->SuspendLayout();
         // 
         // lblElapsed
         // 
         this->lblElapsed->AutoSize = true;
         this->lblElapsed->Location = System::Drawing::Point(457, 242);
         this->lblElapsed->Name = L"lblElapsed";
         this->lblElapsed->Size = System::Drawing::Size(70, 13);
         this->lblElapsed->TabIndex = 70;
         this->lblElapsed->Text = L"Elapsed time:";
         // 
         // cmbNumericFormat
         // 
         this->cmbNumericFormat->FormattingEnabled = true;
         this->cmbNumericFormat->Items->AddRange(gcnew cli::array< System::Object^  >(6) {
            L"Answer: {0}", L"Currency: {0:C2}", L"Fixed: {0:F}",
               L"Percent: {0:P}", L"Scientific: {0:E}", L"Custom: {0:##.0000}"
         });
         this->cmbNumericFormat->Location = System::Drawing::Point(12, 67);
         this->cmbNumericFormat->Name = L"cmbNumericFormat";
         this->cmbNumericFormat->Size = System::Drawing::Size(156, 21);
         this->cmbNumericFormat->TabIndex = 69;
         this->cmbNumericFormat->Text = L"Answer (default format): {0}";
         this->cmbNumericFormat->SelectedIndexChanged += gcnew System::EventHandler(this, &MyForm::cmbNumericFormat_SelectedIndexChanged);
         this->cmbNumericFormat->TextUpdate += gcnew System::EventHandler(this, &MyForm::cmbNumericFormat_TextUpdate);
         this->cmbNumericFormat->TextChanged += gcnew System::EventHandler(this, &MyForm::cmbNumericFormat_TextChanged);
         // 
         // lblFPU
         // 
         this->lblFPU->AutoSize = true;
         this->lblFPU->Location = System::Drawing::Point(301, 117);
         this->lblFPU->Name = L"lblFPU";
         this->lblFPU->Size = System::Drawing::Size(110, 13);
         this->lblFPU->TabIndex = 68;
         this->lblFPU->Text = L"FPU exception masks";
         // 
         // chkFPU
         // 
         this->chkFPU->CheckOnClick = true;
         this->chkFPU->FormattingEnabled = true;
         this->chkFPU->Items->AddRange(gcnew cli::array< System::Object^  >(5) {
            L"Invalid op", L"Division by 0", L"Overflow", L"Underflow",
               L"Precision loss"
         });
         this->chkFPU->Location = System::Drawing::Point(304, 133);
         this->chkFPU->Name = L"chkFPU";
         this->chkFPU->Size = System::Drawing::Size(114, 79);
         this->chkFPU->TabIndex = 67;
         this->chkFPU->SelectedIndexChanged += gcnew System::EventHandler(this, &MyForm::chkFPU_SelectedIndexChanged);
         // 
         // btnSummation
         // 
         this->btnSummation->Location = System::Drawing::Point(460, 204);
         this->btnSummation->Name = L"btnSummation";
         this->btnSummation->Size = System::Drawing::Size(75, 23);
         this->btnSummation->TabIndex = 66;
         this->btnSummation->Text = L"Summation";
         this->btnSummation->UseVisualStyleBackColor = true;
         this->btnSummation->Click += gcnew System::EventHandler(this, &MyForm::btnSummation_Click);
         // 
         // Label1
         // 
         this->Label1->AutoSize = true;
         this->Label1->Location = System::Drawing::Point(457, 128);
         this->Label1->Name = L"Label1";
         this->Label1->Size = System::Drawing::Size(103, 13);
         this->Label1->TabIndex = 65;
         this->Label1->Text = L"Summation from 1 to";
         // 
         // txtSumMax
         // 
         this->txtSumMax->Location = System::Drawing::Point(566, 125);
         this->txtSumMax->Name = L"txtSumMax";
         this->txtSumMax->Size = System::Drawing::Size(81, 20);
         this->txtSumMax->TabIndex = 64;
         this->txtSumMax->Text = L"100000";
         // 
         // txtSumExpression
         // 
         this->txtSumExpression->Location = System::Drawing::Point(460, 151);
         this->txtSumExpression->Name = L"txtSumExpression";
         this->txtSumExpression->Size = System::Drawing::Size(187, 20);
         this->txtSumExpression->TabIndex = 63;
         this->txtSumExpression->Text = L"x^2+5*x-10";
         // 
         // txtSumResult
         // 
         this->txtSumResult->Location = System::Drawing::Point(460, 177);
         this->txtSumResult->Name = L"txtSumResult";
         this->txtSumResult->Size = System::Drawing::Size(187, 20);
         this->txtSumResult->TabIndex = 62;
         // 
         // btnPlot
         // 
         this->btnPlot->Location = System::Drawing::Point(12, 274);
         this->btnPlot->Name = L"btnPlot";
         this->btnPlot->Size = System::Drawing::Size(75, 23);
         this->btnPlot->TabIndex = 61;
         this->btnPlot->Text = L"Plot";
         this->btnPlot->UseVisualStyleBackColor = true;
         this->btnPlot->Click += gcnew System::EventHandler(this, &MyForm::btnPlot_Click);
         // 
         // PictureBox1
         // 
         this->PictureBox1->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
         this->PictureBox1->Location = System::Drawing::Point(12, 145);
         this->PictureBox1->Name = L"PictureBox1";
         this->PictureBox1->Size = System::Drawing::Size(254, 123);
         this->PictureBox1->TabIndex = 60;
         this->PictureBox1->TabStop = false;
         // 
         // txtPlotExpression
         // 
         this->txtPlotExpression->Location = System::Drawing::Point(12, 120);
         this->txtPlotExpression->Name = L"txtPlotExpression";
         this->txtPlotExpression->Size = System::Drawing::Size(254, 20);
         this->txtPlotExpression->TabIndex = 59;
         this->txtPlotExpression->Text = L"-sin(x)/2";
         // 
         // btnDefine
         // 
         this->btnDefine->Location = System::Drawing::Point(304, 39);
         this->btnDefine->Name = L"btnDefine";
         this->btnDefine->Size = System::Drawing::Size(75, 23);
         this->btnDefine->TabIndex = 58;
         this->btnDefine->Text = L"Define";
         this->btnDefine->UseVisualStyleBackColor = true;
         this->btnDefine->Click += gcnew System::EventHandler(this, &MyForm::btnDefine_Click);
         // 
         // cmbDefine
         // 
         this->cmbDefine->FormattingEnabled = true;
         this->cmbDefine->Items->AddRange(gcnew cli::array< System::Object^  >(31) {
            L"Var: x = 123", L"Var: MyString As String = \"Hello\"",
               L"Var: StringB = \"StringB is automatically defined as string because of quotes\"", L"Var: MyInt As Long = 123", L"Const: Pi = Atan(1) * 4",
               L"Func: f(x) = x^2", L"Func: g(x, y) = x * y", L"Func: Twice(x As Double) As Double = x * 2", L"Func: Twice(x As String) As String = x + x",
               L"Func: Area(x) = x ^ 2", L"Func: Area(x, y) = x * y", L"Func: Volume(r, h=0) = IIf(h==0, pi*r^3*4/3, pi*r^2*h/3)", L"Func: Factorial(x) = IIf(x>1, x*Factorial(x-1), 1)",
               L"Func: Fib(n) = IIf(n < 2, n, Fib(n-1) + Fib(n - 2))", L"Func: Test(x As String) As String = MyMsgBox(x) ; x + x", L"Func: TriangleWave(x) = (8/pi^2)*Sum((-1)^((n-1)/2)/(n^2)*Sin(n*x), 1, 100, 2, n)"
               L"",
               L"Op: Precedence(\"*\") {x} ShiftLeft {y} := x * 2^y", L"Op: !{x}  :=  x == 0", L"Op: {x}%  :=  x / 100", L"Syntax: This sentence ::= \"Something Else\"",
               L"Syntax: {\'&b\'}{Number:\'[0-1]+\'} ::= BaseConvert(\'{Number}\', 2)", L"Syntax: Reverse({first}) ::= \'{first}\'", L"Syntax: Reverse({first}, {rest}) ::= Reverse({rest}) + \', {first}\'",
               L"Syntax: MySum({x}) ::= {x}", L"Syntax: MySum({x}, {y}) ::= ({x} + MySum({y}))", L"Syntax: CountArgs({x})      ::= 1", L"Syntax: CountArgs({x}, {y}) ::= ~Eval(1 + CountArgs({y}))",
               L"Syntax: Average({args}) ::= MySum({args}) / CountArgs({args})", L"Syntax: {a} & {b} ::= \"{a}s and {b}s are different\"", L"Syntax: {a} & {a} ::= \"Two {a}s are better than one {a}\"",
               L"Macro: Plus(x) = x + x"
         });
         this->cmbDefine->Location = System::Drawing::Point(304, 12);
         this->cmbDefine->Name = L"cmbDefine";
         this->cmbDefine->Size = System::Drawing::Size(343, 21);
         this->cmbDefine->TabIndex = 57;
         this->cmbDefine->Text = L"Var: MyVariable = 1234.5";
         // 
         // cmbExpression
         // 
         this->cmbExpression->FormattingEnabled = true;
         this->cmbExpression->Items->AddRange(gcnew cli::array< System::Object^  >(27) {
            L".5 + 10", L"5*(((10+3)!-1) MOD 7)^2", L"((2.5+1)*(9-5.5/2)^1.5+COS(ATAN(1)*(3+1/3)))^2",
               L"MyArea(3,4)", L"MyArea(-3,4)", L"IIF(1 > 2, 1/0, 3)", L"IIF(1 > 2, \"True\", \"False\")", L"IIF(1 > 2, MyMsgBox(\"Yes\"), MyMsgBox(\"No\"))",
               L"MyIIF(1 > 2, 1/0, 3)", L"MyIIF(1 > 2, \"True\", \"False\")", L"MyIIF(1 > 2, MyMsgBox(\"Yes\"), MyMsgBox(\"No\"))", L"Solve(x^2 + 1 = 26)",
               L"Solve(x^2 + 1 = 26, -1000, 0)", L"Sum(2*x + 5, 1, 10)", L"\"Hello \" + \"world\"", L"\"This\" > \"That\"", L"\'This\' < \'That\'",
               L"Asc(\"D\")", L"#hAE.B1 + #b1110.1001", L"NonNativeFunc(2.5, 10.3, 6)", L"MsgBox(\"Please send feedback at www.ucalc.com\")",
               L"MsgBox(\"Something\", 2)", L"MsgBox(\"Great\",, \"New Title\")", L"MyAverage(1,2,3,4,5,6)", L"MyLeft(\"Hello There\", 7)",
               L"MsgBox(\"First box\") ; MsgBox(\"Second Box\",, \"Title\") ; 123", L"\"Hello \" * 3"
         });
         this->cmbExpression->Location = System::Drawing::Point(12, 12);
         this->cmbExpression->Name = L"cmbExpression";
         this->cmbExpression->Size = System::Drawing::Size(254, 21);
         this->cmbExpression->TabIndex = 56;
         this->cmbExpression->Text = L"3+4/5-8";
         // 
         // btnEval
         // 
         this->btnEval->Location = System::Drawing::Point(191, 65);
         this->btnEval->Name = L"btnEval";
         this->btnEval->Size = System::Drawing::Size(75, 23);
         this->btnEval->TabIndex = 55;
         this->btnEval->Text = L"Evaluate";
         this->btnEval->UseVisualStyleBackColor = true;
         this->btnEval->Click += gcnew System::EventHandler(this, &MyForm::btnEval_Click);
         // 
         // txtResult
         // 
         this->txtResult->Location = System::Drawing::Point(12, 39);
         this->txtResult->Name = L"txtResult";
         this->txtResult->Size = System::Drawing::Size(254, 20);
         this->txtResult->TabIndex = 54;
         // 
         // MyForm
         // 
         this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
         this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
         this->ClientSize = System::Drawing::Size(663, 308);
         this->Controls->Add(this->lblElapsed);
         this->Controls->Add(this->cmbNumericFormat);
         this->Controls->Add(this->lblFPU);
         this->Controls->Add(this->chkFPU);
         this->Controls->Add(this->btnSummation);
         this->Controls->Add(this->Label1);
         this->Controls->Add(this->txtSumMax);
         this->Controls->Add(this->txtSumExpression);
         this->Controls->Add(this->txtSumResult);
         this->Controls->Add(this->btnPlot);
         this->Controls->Add(this->PictureBox1);
         this->Controls->Add(this->txtPlotExpression);
         this->Controls->Add(this->btnDefine);
         this->Controls->Add(this->cmbDefine);
         this->Controls->Add(this->cmbExpression);
         this->Controls->Add(this->btnEval);
         this->Controls->Add(this->txtResult);
         this->Name = L"MyForm";
         this->Text = L"uCalc Fast Math Parser 3 demo for VC++";
         this->Load += gcnew System::EventHandler(this, &MyForm::MyForm_Load);
         (cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->PictureBox1))->EndInit();
         this->ResumeLayout(false);
         this->PerformLayout();

      }
#pragma endregion
       public:
          static uCalc uc;
          static String ^ NumericFormat = "{0}";
          static float OldX, OldY;
          static Graphics ^ g;
          static Pen ^ myPen;

          static void MyErrorHandler(uCalcPtr uCalcHandle)
          {
             auto uc = uCalc(uCalcHandle);
             static bool DisplayAgain = true;

             if (DisplayAgain) {
                auto Option = MessageBox::Show(
                   "uCalc Error (this message box is part of the demo)\n\n"
                   + "Error Number: " + Convert::ToString(uc.ErrorNumber()) + "  [" /* + Enum::GetName(ErrorNumberEnum::typeid, uc.ErrorNumber()) */ + "]\n"
                   + "Bad expression: " + uc.ErrorExpression() + "\n"
                   + "Error Handler message: " + uc.ErrorMessage() + "\n"
                   + "Offending symbol: " + uc.ErrorSymbol() + "\n"
                   + "Error Location: " + Convert::ToString(uc.ErrorLocation()) + "\n\n"
                   + "See MyErrorHandler(), in MyFunctions.vb, for error handler source code.\n\n"
                   + "Show this message next time?", "uCalc Error (this message box is part of the demo)", MessageBoxButtons::YesNoCancel);
                if (Option == System::Windows::Forms::DialogResult::No) DisplayAgain = false;
             }
          }

          static void MyNumericFormat(uCalcPtr ExprPartPtr) {
             auto uc = uCalc::Callback(ExprPartPtr);
             String ^ ResultAsString = uc.ArgStr(1);

             try {
                String ^ FormattedResult = String::Format(MyForm::NumericFormat, Convert::ToDouble(ResultAsString));
                uc.ReturnStr(FormattedResult);
             }
             catch (...) { // +++ For special values like -1.#IND, -1.#INF, etc..
                uc.ReturnStr(ResultAsString);
             }
          }


          static void MyArea(uCalcPtr ExprPartPtr)
          {
             auto uc = uCalc::Callback(ExprPartPtr);
             auto MyLength = uc.Arg(1);
             auto MyWidth = uc.Arg(2);

             if (MyLength < 0) uc.ErrorRaiseMessage("Length cannot be negative");
             if (MyWidth  < 0) uc.ErrorRaiseMessage("Width cannot be negative");

             uc.Return(MyLength * MyWidth);
          }

          /* +++

          long double _stdcall NonNativeFunc(double a, long& b, byte c)
          {
          return a + b + c;
          }
          */


          static void MyIIF_Numeric(uCalcPtr ExprPartPtr)
          {
             auto uc = uCalc::Callback(ExprPartPtr);
             auto Condition = uc.Arg(1);
             auto TruePart = uc.ArgExpr(2);
             auto FalsePart = uc.ArgExpr(3);

             if (Condition != 0)
                uc.Return(TruePart.Evaluate());
             else
                uc.Return(FalsePart.Evaluate());
          }


          static void MyIIF_String(uCalcPtr ExprPartPtr)
          {
             auto uc = uCalc::Callback(ExprPartPtr);
             auto Condition = uc.Arg(1);
             auto TruePart = uc.ArgExpr(2);
             auto FalsePart = uc.ArgExpr(3);

             if (Condition != 0)
                uc.ReturnStr(TruePart.EvaluateStr());
             else
                uc.ReturnStr(FalsePart.EvaluateStr());
          }




          static void MyMsgBox(uCalcPtr ExprPartPtr)
          {
             auto uc = uCalc::Callback(ExprPartPtr); // Args 2 & 3 inverted because it's based on VB MsgBox syntax
             uc.Return((int)MessageBox::Show(uc.ArgStr(1), uc.ArgStr(3), (MessageBoxButtons)(int)uc.Arg(2)));
          }



          static void MyAverage(uCalcPtr ExprPartPtr)
          {
             auto uc = uCalc::Callback(ExprPartPtr);
             double Total = 0;

             for (int x = 1; x <= uc.ArgCount(); x++)
                Total = Total + uc.Arg(x);

             uc.Return(Total / uc.ArgCount());
          }


          static void MyLeft(uCalcPtr ExprPartPtr)
          {
             auto uc = uCalc::Callback(ExprPartPtr);
             uc.ReturnStr(uc.ArgStr(1)->Substring(0, (int)uc.Arg(2)));
          }


          static void StringRepeat(uCalcPtr ExprPartPtr)
          {
             auto uc = uCalc::Callback(ExprPartPtr);
             String ^ TotalString("");

             for (int x = 1; x <= uc.Arg(2); x++)
                TotalString = TotalString + uc.ArgStr(1);

             uc.ReturnStr(TotalString);
          }


          static void ucSum(uCalcPtr ExprPartPtr)
          {
             auto uc = uCalc::Callback(ExprPartPtr);
             double Total = 0;

             auto Expression = uc.ArgExpr(1);
             auto Start = uc.Arg(2);
             auto Finish = uc.Arg(3);
             auto sStep = uc.Arg(4);
             auto VarHandle = uc.ArgObj(5);

             for (double x = Start; x <= Finish; x += sStep)
             {
                VarHandle.SetVariableValue(x);
                Total = Total + Expression.Evaluate();
                x = x + sStep;
             }

             uc.Return(Total);
          }

#define ABS(x) (x > 0 ? x : -x)
          static void ucSolve(uCalcPtr ExprPartPtr)
          {
             auto uc = uCalc::Callback(ExprPartPtr);
             auto Expression = uc.ArgExpr(1);
             auto a = uc.Arg(2);
             auto b = uc.Arg(3);
             auto Variable = uc.ArgObj(4);

             int Iterations = 0;
             double fa, fb, Value = 0, tmp;

             Variable.SetVariableValue(a);
             fa = Expression.Evaluate();

             Variable.SetVariableValue(b);
             fb = Expression.Evaluate();

             if (fb < fa) { tmp = a; a = b; b = tmp; }  // swap a, b

             while (ABS(b - a) > 0.000000000000001)
             {
                Variable.SetVariableValue((a + b) / 2);

                Value = Expression.Evaluate();

                if (Value == 0) { a = (a + b) / 2; break; }

                if (Value < 0) a = (a + b) / 2; else b = (a + b) / 2;

                Iterations = Iterations + 1;
                if (Iterations == 100) break;
             }

             if (ABS(Value) > 0.0000000001) uc.ErrorRaiseMessage("Solution not found");
             uc.Return(a);
          }

   private: System::Void MyForm_Load(System::Object^  sender, System::EventArgs^  e) {
      myPen = gcnew Pen(Color::Black);
      g = PictureBox1->CreateGraphics();

      // Toggle the FPU to depending on whether you want to raise an error, or silently return special values for 1/0 etc.            
      chkFPU->SetItemCheckState(3, CheckState::Checked); // Checkmarks underflow mask
      chkFPU->SetItemCheckState(4, CheckState::Checked); // Checkmarks precision mask

                                                         // The MyErrorHandler() function will be called whenever and wherever an error (such as "Syntax Error") is raised.	
      uc.AddErrorHandler(ucPinAddr(MyErrorHandler));

      // SetOutput lets you configure the formatting of results returned with EvalStr() or EvaluateStr()			
      uc.SetOutput(ucPinAddr(MyNumericFormat), "Double");

      // MyArea() returns the product of multiplying the two arguments.
      // MyLeft() returns the left-most characters of a string.  The second argument represents the number of characters.
      // MsgBox() displays a message box.  The 1st argument is required.  The others are optional.
      uc.DefineFunction("MyArea(Length, Width)", ucPinAddr(MyArea));
      uc.DefineFunction("MyLeft(Text As String, Count) As String", ucPinAddr(MyLeft));
      uc.DefineFunction("MyMsgBox(Prompt As String, Buttons = 0, Title As String = 'uCalc')", ucPinAddr(MyMsgBox));
      uc.ParserTransform().FromTo("MsgBox ::= MyMsgBox");

      // The three consecutive dots "..." mean that MyAverage can take any number of arguments
      // (however, because "x" is specified, there must be at least one argument).
      uc.DefineFunction("MyAverage(x ...)", ucPinAddr(MyAverage));

      // Two versions of MyIIF can co-exist peacefully with the same name because
      // they are defined with different argument types (numeric vs string).
      // By passing the last two arguments ByExpr, the callback can chose to evaluate only one of of them.  
      uc.DefineFunction("MyIIf(cond, ByExpr TruePart, ByExpr FalsePart)", ucPinAddr(MyIIF_Numeric));
      uc.DefineFunction("MyIIf(cond, ByExpr TruePart As String, ByExpr FalsePart As String) As String", ucPinAddr(MyIIF_String));

      // The following defines the "*" operator so that MyString * n returns MyString repeated n times.
      // For instance, "He " * 3, would return "He He He".  20 represents the precedence level.  It is
      // arbitrarily set at the same level as that of the numeric "*" multiplication operator.
      //+++uc.DefineOperator("{MyString As String} * {Number} As String", gcnew uc.Item(uc.HandleOf("*")).Precedence(), GroupingEnum::GroupLeftToRight, ucPinAddr(StringRepeat));

      // This definition is for a summation.  See the callback ucSum() routine for the
      // actual code, which runs a loop that adds up the total for the expression in
      // the first argument a number of times based on the second and third arguments.
      // For instance Sum(g^2+1, 1, 5, 1, g) returns 60 and Sum(x^2, 1, 10) returns 385.
      // The last two arguments are optional, so they default to 1 and x if omitted.
      //
      // The first argument is passed "ByExpr".  So instead of being evaluated before
      // being passed to the callback the way an ordinary argument would be, a handle
      // for the expression is passed so that the callback can evaluate it (in this
      // case numerous times).
      //
      // The last argument is passed "ByHandle".  This causes the callback to receive
      // a handle for the variable being passed, in such a way that it can be linked to
      // the summation counter, and integrated into the expression in the first argument.
      //
      // The actual function being defined is Sum_().  Then a syntax construct named
      // Sum() is defined in such a way that the last argument gets defined as a local
      // variable.  So if you evaluate Sum(x^2, 5, 10, 1, x), the local "x" in this
      // expression will not interfere with a pre-existing variable named x.  Also you
      // do not need to declare a variable ahead of time to use it as a counter for Sum().
      uc.DefineFunction("Sum_(ByExpr Expr, Start, Finish, Step, ByHandle Var)", ucPinAddr(ucSum));
      uc.ParserTransform().FromTo("Sum({Expr}, {Start}, {Finish} [, {Step=1} [, {Var=x}]])"
         + "::= Local({Var}, Sum_({Expr}, {Start}, {Finish}, {Step}, {Var}))");

      // The following routine solves an equation.
      // The callback code is based on the Bisection Method algorithm.
      // The concept here is very similar to that of Sum().
      // Two syntax constructs are defined.  The second one rearranges the equation
      // if it includes an equal sign.
      // For instance Solve(x^2 = 9+x) becomes Solve(x^2 - (9+x))
      // Solve(x^2 + 1 = 26) returns 5.
      // Solve(x^2 + 1 = 26, -1000, 0) returns -5.
      uc.DefineFunction("Solve_(ByExpr Expr, a, b, ByHandle Var)", ucPinAddr(ucSolve));
      uc.ParserTransform().FromTo("Solve({Expr} [, {a=-100000000} [, {b=100000000} [, {Var=x}]]]) "
         + "::= Local({Var}, Solve_({Expr}, {a}, {b}, {Var}))");
      uc.ParserTransform().FromTo("Solve({Left} = {Right} [, {etc}]) ::= Solve({Left}-({Right}) {etc: , {etc}})");
   }
   private: System::Void btnEval_Click(System::Object^  sender, System::EventArgs^  e) {
      // Eval() evaluates an expression and returns a numeric result.
      // EvalStr() can evaluate expressions of any data type (numeric, string, or other).
      // EvalStr() conveniently converts numeric results to strings for you.
      // EvalStr() can also return the text of an error message.

      txtResult->Text = uc.EvalStr(cmbExpression->Text);
   }
private: System::Void btnDefine_Click(System::Object^  sender, System::EventArgs^  e) {
   // Define() can define a variable, constant, function, operator,
   // syntax construct, pattern, data type, and more.

   uc.Define(cmbDefine->Text);
}
private: System::Void btnSummation_Click(System::Object^  sender, System::EventArgs^  e) {
   double SumTotal = 0, SumMax = Convert::ToDouble(txtSumMax->Text);
   Stopwatch ^ MyStopWatch = Stopwatch::StartNew();

   auto VariableX = uc.DefineVariable("x");
   auto Expression = uc.Parse(txtSumExpression->Text);

   for (double x = 1; x <= SumMax; x++)
   {
      VariableX.SetVariableValue(x);
      SumTotal = SumTotal + Expression.Evaluate();
   }
   MyStopWatch->Stop();

   txtSumResult->Text = SumTotal.ToString();
   lblElapsed->Text = "Elapsed Time:  " + Convert::ToString((double)MyStopWatch->ElapsedMilliseconds / 1000);

   Expression.Release();
   VariableX.Release();
}

         private: void CartesianLineTo(double x, double y)
         {
            float NewX, NewY;

            if (x == -10) { OldX = 0; OldY = 0; }

            NewX = (float)(PictureBox1->Size.Width * (x + 10) / 20);
            NewY = (float)(PictureBox1->Size.Height * (2 - y) / 4);

            g->DrawLine(myPen, OldX, OldY, NewX, NewY);

            OldX = NewX;
            OldY = NewY;
         }
private: System::Void btnPlot_Click(System::Object^  sender, System::EventArgs^  e) {
   g->Clear(Color::White);

   auto Variable = uc.DefineVariable("x");
   auto Equation = uc.Parse(txtPlotExpression->Text);

   for (double x = -10; x <= 10; x += 0.125)
   {
      Variable.SetVariableValue(x);
      CartesianLineTo(x, Equation.Evaluate());
   }

   Equation.Release();
   Variable.Release();
}
private: System::Void chkFPU_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) {
   switch (chkFPU->SelectedIndex)
   {
   case 0: uc.FPEnvToggleExceptionMask(Invalid); break;
   case 1: uc.FPEnvToggleExceptionMask(DivisionByZero); break;
   case 2: uc.FPEnvToggleExceptionMask(Overflow); break;
   case 3: uc.FPEnvToggleExceptionMask(Underflow); break;
   case 4: uc.FPEnvToggleExceptionMask(Inexact); break;
   }
}
private: System::Void cmbNumericFormat_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) {
   NumericFormat = cmbNumericFormat->Text;
}
private: System::Void cmbNumericFormat_TextUpdate(System::Object^  sender, System::EventArgs^  e) {
   NumericFormat = cmbNumericFormat->Text;
}
private: System::Void cmbNumericFormat_TextChanged(System::Object^  sender, System::EventArgs^  e) {
   NumericFormat = cmbNumericFormat->Text;
}
};
}
